#version 330 core

in vec4 wsPosition;
in vec3 normal;
in vec2 fragTexCoords;

layout(location = 0) out vec4 diffuseColor;

uniform vec3 lightPos;
uniform float far_plane;
uniform sampler2D texture_diffuse1;
//uniform samplerCube skybox;

void main()
{
    // get distance between fragment and light source
    float lightDistance = length(wsPosition.xyz - lightPos);
    
    // map to [0;1] range by dividing by far_plane
    lightDistance = lightDistance / far_plane;
  
    gl_FragDepth = lightDistance;

	//gl_FragColor = vec4(texture(texture_diffuse1, fragTexCoords)) + vec4(texture(skybox, normal));
	diffuseColor = vec4(texture(texture_diffuse1, fragTexCoords));
	
}  