#version 330 core

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

uniform mat4 lightSpaceMatrices[6];

in vec2 gTexCoords[];
in vec3 gNormals[];
out vec4 wsPosition; 
out vec3 normal;
out vec2 fragTexCoords;

void main()
{
    for(int face = 0; face < 6; ++face)
    {
        gl_Layer = face; // built-in variable, specifies which cubemap face to emit a primitive to

		// 3 vertices in a triangle
        for(int i = 0; i < 3; ++i) 
        {
            wsPosition = gl_in[i].gl_Position;
			fragTexCoords = gTexCoords[i];
			normal = gNormals[i];
			//transform world-space vertex to light space
            gl_Position = lightSpaceMatrices[face] * wsPosition; 

            EmitVertex();
        }    

        EndPrimitive();
    }
}  