#version 330 core
out vec4 FragColor;
in vec2 TexCoords;

uniform sampler2D image;
uniform bool horizontal;

//uniform float weight[5] = float[] (0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);

uniform float weight[10] = float[] ( 0.199471459508512,   0.176032945170291,   0.120985555929540,
   0.064758901497010,   0.026995526470205,   0.008764164276190,
   0.002215927753158,   0.000436342046006,   0.000066915219998,   0.000007991883347);



void main()
{             
     vec2 tex_offset = 1.0 / textureSize(image, 0); // gets size of single texel
     vec3 result = texture(image, TexCoords).rgb * weight[0];
     if(horizontal)
     {
         for(int i = 1; i < 10; ++i)
         {
            result += texture(image, TexCoords + 2*vec2(tex_offset.x * i, 0.0)).rgb * weight[i];
            result += texture(image, TexCoords - 2*vec2(tex_offset.x * i, 0.0)).rgb * weight[i];
         }
     }
     else
     {
         for(int i = 1; i < 10; ++i)
         {
             result += texture(image, TexCoords + 2*vec2(0.0, tex_offset.y * i)).rgb * weight[i];
             result += texture(image, TexCoords - 2*vec2(0.0, tex_offset.y * i)).rgb * weight[i];
         }
     }
     FragColor = vec4(result, 1.0);
}