#version 330                                                                        
                                                                                    
layout(points) in;                                                                  
layout(triangle_strip) out;                                                         
layout(max_vertices = 4) out;    

in float gAge[];      
out float Age;                                            
                                                                                    
uniform mat4 gVP;                                                                   
uniform vec3 viewPos;                                                            
                                                                                                                                            
                                                                                    
void main()                                                                         
{   
	float factor = 0.0;
	if ((gAge[0] > 500) && (gAge[0] < 10000)) {
		factor = (gAge[0] / 10000);
	}
	

	float dim = 0.2 * (1 - factor);  
	if(dim < 0.01f) {
		dim = 0.01f;
	}                                                                             
    vec3 Pos = gl_in[0].gl_Position.xyz;                                            
    vec3 toCamera = normalize(viewPos - Pos);                                    
    vec3 up = vec3(0.0, 1.0, 0.0);                                                  
    vec3 right = cross(toCamera, up);                                               
                                          
	Age = gAge[0];                                          
    Pos -= (right * dim);                                                           
    gl_Position = gVP * vec4(Pos, 1.0);                                                                                                  
    EmitVertex();                                                                   
                                     
    Age = gAge[0];                                           
    Pos.y += dim;                                                                   
    gl_Position = gVP * vec4(Pos, 1.0);                                                                                                 
    EmitVertex();                                                                   
    
	Age = gAge[0];                                                                                
    Pos.y -= dim;                                                                   
    Pos += right * dim;                                                                   
    gl_Position = gVP * vec4(Pos, 1.0);                                                                                                 
    EmitVertex();                                                                   
    
	Age = gAge[0];                                                                                
    Pos.y += dim;                                                                   
    gl_Position = gVP * vec4(Pos, 1.0);                                                                                               
    EmitVertex();                                                                   
                                                                                    
    EndPrimitive();                                                                 
}                                                                                   
