#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec2 fragTexCoords;
out vec3 fragNormal;
out vec3 fragWSPosition; // vertex position that is in world space
out vec4 fragLightSpacePosition;
out vec4 interpolatedVertexEye; 

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 lightSpaceMatrix;

void main()
{
	interpolatedVertexEye = model *  vec4(position, 1.0f);
    // gl_Position = projection * view * model * vec4(position, 1.0f);
	gl_Position = projection * view * model * vec4(position, 1.0f);
	fragWSPosition = vec3(model * vec4(position, 1.0f));
    fragTexCoords = texCoords;
	fragNormal =  mat3(transpose(inverse(model))) * normal;  
	fragLightSpacePosition = lightSpaceMatrix * vec4(fragWSPosition, 1.0);
}