#version 330 core

in vec2 TexCoords;
in vec3 normal;

out vec4 color;

uniform sampler2D texture_diffuse1;
uniform sampler2D texture_bloom;

void main()
{    
	const float exposure = 0.7;
	const float gamma = 1.2;
    vec3 hdrColor = texture(texture_diffuse1, TexCoords).rgb
						+ texture(texture_bloom, TexCoords).rgb;
  
        // Exposure tone mapping
    vec3 mapped = vec3(1.0) - exp(-hdrColor * exposure);
    // Gamma correction 
    mapped = pow(mapped, vec3(1.0 / gamma));
  
    color = vec4(mapped, 1.0);


   // color = vec4(texture(texture_diffuse1, TexCoords));
	// color = vec4(normal, 1.0f);
}