

////////////--------------- START: OCEAN -----------------

#version 330 core

layout(location = 0) in vec3 position;

uniform mat4 model; 
uniform mat4 view;
uniform mat4 projection;

uniform float time;
uniform vec3 cameraPos;

out vec4 waveSize0;
out vec2 waveSize1;
out vec2 waveSize2;
out vec2 waveSize3;
out vec2 waveSize4;

out vec4 screenPos;
out vec3 eyePos;


void main()
{
	gl_Position = projection * view * model * vec4(position, 1.0f);
	vec3 fragPos = vec3(model * vec4(position, 1.0f));

	vec2 translation = vec2(0.0, mod(time/1600.0, 4000)*0.0007); //loop and scale time
	vec2 vTexCoords = fragPos.xz*0.00005; 

//big & small waves to be averaged
	waveSize0.xy = vTexCoords.xy + translation;
	waveSize1 = vTexCoords.xy*25.0 + translation*10.0;;
	waveSize2 = vTexCoords.xy*40.0 + translation*20.0;
	waveSize3 = vTexCoords.xy*90.0 + translation*120;
	waveSize4 = vTexCoords.xy*130.0 + translation;

	// mirror perspective  
	vec4 mirPos = gl_Position;
	mirPos.y = -mirPos.y;

	waveSize0.w = mirPos.w;

	screenPos.xy = (mirPos.xy + mirPos.w)*0.5;
	screenPos.zw = vec2(1.0, mirPos.w);

	vec3 eye = cameraPos.xyz - fragPos;
	eyePos = mat3(vec3(0, 1, 0), vec3(0, 0, 1), vec3(1, 0, 0))* eye; //to tangent
}

//////////--------------- END: OCEAN -----------------





//////--------------- START: MIRROR -----------------
//#version 330 core

//layout (location = 0) in vec3 position;

//uniform mat4 model;
//uniform mat4 view;
//uniform mat4 projection;

//out vec3 interpolate;

//void main()
//{
//	gl_Position = projection * view * model *  vec4(position.xy, 0.0, 1.0);
//	interpolate = position;
//}

////--------------- END: MIRROR -----------------



////--------------- START: SIMPLE -----------------

//#version 330 core
//layout (location = 0) in vec3 position;
//layout (location = 1) in vec3 normal;
//layout (location = 2) in vec2 texCoords;

//out vec2 TexCoords;
////out vec3 normal; // BUG?

//uniform mat4 model;
//uniform mat4 view;
//uniform mat4 projection;

//void main()
//{
//    gl_Position = projection * view * model * vec4(position, 1.0f);
//	//gl_Position = MVPMatrix * vec4(position, 1.0f);
//    TexCoords = texCoords;
//}

////--------------- END: SIMPLE -----------------
