
#version 330 core
in vec3 texCoords;
layout (location = 0) out vec4 fragColor;
layout (location = 1) out vec4 brightColor;

uniform samplerCube skybox;

void main()
{    
    fragColor = texture(skybox, texCoords);
	float brightness = dot(fragColor.rgb, vec3(0.2126, 0.7152, 0.0722)); // definition luminance
	if (brightness > 0.9) {
		brightColor = fragColor * 0.25;
	}
}