#version 330 core

in vec3 fragWSPosition;
in vec3 fragNormal;
uniform vec3 lightColor;
uniform samplerCube environmentMap;
uniform samplerCube skybox;
uniform vec3 viewPos;

out vec4 color;

void main()
{     
	//float ratio = 1.00 / 2.309;
	vec3 viewVector = normalize(fragWSPosition - viewPos);
	vec3 reflectVector = reflect(viewVector, normalize(fragNormal));
	color = (vec4(texture(environmentMap, reflectVector)) 
						+ vec4(texture(skybox, reflectVector))
						+ vec4(lightColor, 1.0)) * 2; 
	//+ vec4(normalize(lightColor), 1.0f));
    //color = vec4(normalize(lightColor), 0.5f);
}